"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scriptMessageHandler = void 0;
const frida_js_1 = require("./frida.js");
const brolog_1 = require("brolog");
const scriptMessageHandler = (message, data) => {
    brolog_1.log.verbose('Sidecar', 'scriptMessageHandler(%s, %s)', JSON.stringify(message), data);
    switch (message.type) {
        case frida_js_1.MessageType.Send:
            brolog_1.log.silly('Sidecar', 'scriptMessagerHandler() MessageType.Send: %s', JSON.stringify(message.payload));
            break;
        case frida_js_1.MessageType.Error:
            brolog_1.log.silly('Sidecar', 'scriptMessagerHandler() MessageType.Error: %s', message.stack);
            break;
        default:
            throw new Error('Sidecar/scriptMessagerHandler() Error: unknown message type: ' + message);
    }
    if (data) {
        brolog_1.log.silly('Sidecar', 'scriptMessageHandler() data:', data);
    }
};
exports.scriptMessageHandler = scriptMessageHandler;
//# sourceMappingURL=script-message-handler.js.map