"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractClassNameList = exports.extractClassNameListFromSource = void 0;
const promises_1 = __importDefault(require("fs/promises"));
async function extractClassNameList(url) {
    const content = await promises_1.default.readFile(url, 'utf-8');
    return extractClassNameListFromSource(content);
}
exports.extractClassNameList = extractClassNameList;
async function extractClassNameListFromSource(source) {
    /**
     * Extract the @Sidecar decorated classes
     */
    const REGEXP = /@Sidecar\s*\(.*?\)\s*(?:export)?\s*class\s+([A-Za-z0-9\-_]+)\s+/sg;
    return Array.from(source.matchAll(REGEXP)).map(m => m[1]);
}
exports.extractClassNameListFromSource = extractClassNameListFromSource;
//# sourceMappingURL=extract-class-names.js.map