#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const metadata_call_js_1 = require("./metadata-call.js");
(0, tstest_1.test)('update & get call target metadata', async (t) => {
    const PROPERTY_KEY = 'key';
    const TARGET = {
        [PROPERTY_KEY]: () => { },
    };
    const CALL_TARGET = 0x42;
    (0, metadata_call_js_1.updateMetadataCall)(TARGET, PROPERTY_KEY, CALL_TARGET);
    const data = (0, metadata_call_js_1.getMetadataCall)(TARGET, PROPERTY_KEY);
    t.same(data, CALL_TARGET, 'should get the call target data the same as we set(update');
});
//# sourceMappingURL=metadata-call.spec.js.map