"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSidecarTargetSpawn = exports.isSidecarTargetProcess = exports.normalizeSidecarTarget = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const config_js_1 = require("../../config.js");
const sidecarTargetObjProcess = (target) => ({
    target,
    type: 'process',
});
const sidecarTargetObjSpawn = (target) => ({
    target,
    type: 'spawn',
});
const normalizeSidecarTarget = (target) => {
    if (typeof target === 'string' || typeof target === 'number') {
        return sidecarTargetObjProcess(target);
    }
    else if (Array.isArray(target)) {
        const command = path_1.default.resolve(process.cwd(), target[0]);
        if (fs_1.default.existsSync(command)) {
            config_js_1.log.verbose('Sidecar', 'normalizeSidecarTarget() spawn command found: "%s"', command);
            target[0] = command;
        }
        else {
            config_js_1.log.warn('Sidecar', 'normalizeSidecarTarget() spawn command not found: "%s"', command);
        }
        return sidecarTargetObjSpawn(target);
    }
    else {
        return target;
    }
};
exports.normalizeSidecarTarget = normalizeSidecarTarget;
const isSidecarTargetProcess = (target) => typeof target === 'object' && !Array.isArray(target) && target.type === 'process';
exports.isSidecarTargetProcess = isSidecarTargetProcess;
const isSidecarTargetSpawn = (target) => typeof target === 'object' && !Array.isArray(target) && target.type === 'spawn';
exports.isSidecarTargetSpawn = isSidecarTargetSpawn;
//# sourceMappingURL=target.js.map