"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.moduleName = void 0;
const path_1 = __importDefault(require("path"));
const target_js_1 = require("../decorators/sidecar/target.js");
function moduleName() {
    const targetObj = this.sidecarTarget;
    if (!targetObj) {
        throw new Error('no target found in SidecarMetadata');
    }
    if ((0, target_js_1.isSidecarTargetProcess)(targetObj)) {
        return typeof targetObj.target === 'number'
            ? targetObj.target
            : path_1.default.win32.basename(targetObj.target);
    }
    else if ((0, target_js_1.isSidecarTargetSpawn)(targetObj)) {
        // See: https://nodejs.org/api/path.html
        return path_1.default.win32.basename(targetObj.target[0]);
    }
    else {
        throw new Error('unknown target obj: ' + JSON.stringify(targetObj));
    }
}
exports.moduleName = moduleName;
//# sourceMappingURL=module-name.js.map