import { log, } from '../../config.js';
import { updateMetadataRetType, } from './metadata-ret-type.js';
import { guardRetType } from './guard-ret-type.js';
function RetType(nativeType, ...pointerTypeList) {
    log.verbose('Sidecar', '@RetType(%s%s)', nativeType, pointerTypeList.length > 0
        ? `, [${pointerTypeList.join(',')}]`
        : '');
    return function retTypeMethodDecorator(target, propertyKey, _descriptor) {
        log.verbose('Sidecar', '@RetType(%s%s) retTypeMethodDecorator(%s, %s, descriptor)', nativeType, pointerTypeList.length > 0
            ? `, [${pointerTypeList.join(',')}]`
            : '', target.constructor.name, propertyKey);
        guardRetType(target, propertyKey, nativeType, pointerTypeList);
        updateMetadataRetType(target, propertyKey, [nativeType, ...pointerTypeList]);
    };
}
export { RetType };
//# sourceMappingURL=ret-type.js.map