#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
import { test } from 'tstest';
import { normalizeFunctionTarget, } from './function-target.js';
test('PointerType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'PointerType should be typing right');
});
test('NativeType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'NativeType should be typing right');
});
test('TargetType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'TargetType should be typing right');
});
test('ScriptMessageHandler typing', async (t) => {
    const handler = {};
    const typeTest = true;
    t.ok(typeTest, 'ScriptMessageHandler should be typing right');
});
test('normalizeFunctionTarget()', async (t) => {
    const TEST_LIST = [
        [
            'stringTarget',
            { funcName: 'stringTarget', type: 'agent' },
        ],
        [
            0x42,
            { address: '0x42', moduleName: null, type: 'address' },
        ],
    ];
    const result = TEST_LIST.map(pair => pair[0]).map(normalizeFunctionTarget);
    const expected = TEST_LIST.map(pair => pair[1]);
    t.same(result, expected, 'should normalize function target as expected');
});
//# sourceMappingURL=frida.spec.js.map